option explicit
option default none
mode 2
page write 1
const edgelength=100 'set the length of the verticies of the ticosahedron
const xloc=mm.hres/2 'X location - center of the screen
const yloc=mm.vres/2 'Y location - center of the screen
const zloc=1000      'how far is the center of the ticosahedron away from us
const viewplane=800  'how far is the viewplane away from us
dim float x,y,d,f
dim float x1,y1,z1
dim integer col(11), sortorder(11)
dim float q1(4),depth(11),v(4), vout(4)
dim float phi=(1+sqr(5))/2
'
dim float zpos(31),zsort(31)
dim float ticos(2,59), nticos(3,59)
dim integer i,j,k,l,m,n
dim integer xs(179),ys(179),xe(179),ye(179)
dim integer index(31),nnum(31)
'
dim integer xarr(179),yarr(179)
' Number of vertices per face
dim integer nv(31)=(5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6)
dim integer np(31)=(0,1,2,3,4,5,6,7,8,9,10,11,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19)
dim integer nd(31)
dim integer f5(4,11), f6(5,19)
dim integer ncol(31)

' read the polygon vertices and faces
'
' read in the coordinates of the verticies and scale
for j=0 to 59
  for i=0 to 2
    ' read the coordinate
    read ticos(i,j)
    ' apply the edge length to the coordinate
    ticos(i,j)=ticos(i,j)*edgelength/2
  next i
next j
' read the 5 sided faces
for j=0 to 11
  for i=0 to 4
    read f5(i,j)
  next i
next j
' read the 6 sided faces
for j=0 to 19
  for i=0 to 5
    read f6(i,j)
  next i
next j
'
'convert coordinates to normalised form
for i=0 to 59
    x1=ticos(0,i): y1=ticos(1,i): z1=ticos(2,i)
    math q_vector x1,y1,z1,v()
    nticos(0,i)=v(1): nticos(1,i)=v(2): nticos(2,i)=v(3): nticos(3,i)=v(4)
next i
'create a quarternion to rotate 4 degrees about a chosen axis
'play with the x,y,z vector which is the sxis of rotation
math q_create rad(4), 1,0.5,0.25,q1()
do
  cls
  for i=0 to 59 'rotate coordinates
    v(1)=nticos(0,i)
    v(2)=nticos(1,i)
    v(3)=nticos(2,i)
    v(0)=nticos(3,i)
    v(4)=0
    math q_rotate q1(),v(),vout()
    nticos(0,i)=vout(1)
    nticos(1,i)=vout(2)
    nticos(2,i)=vout(3)
    nticos(3,i)=vout(0)
  next i
  '
  ' average the z positions for the five sided faces
  for j=0 to 11
    zpos(j)=0
    for i=0 to 4
      zpos(j)=zpos(j)+nticos(2,f5(i,j))
    next i
    zpos(j)=zpos(j)/5
    index(j)=j
  next j
  'average the z positions for the 6 sided faces
  for j=12 to 31
    zpos(j)=0
    for i=0 to 5
      zpos(j)=zpos(j)+nticos(2,f6(i,j-12))
    next i
    zpos(j)=zpos(j)/6
    '
    index(j)=j
  next j
  ' sort the z positions to render far faces first
  sort zpos(),index()
  ' project the 3D vertices onto a 2D plane
  j=0:m=0
  for l=0 to 31
    k=index(l)
    m=np(k)
    nd(l)=nv(k)
    if nv(k)=5 then
      ncol(l)=rgb(red)
    else
      ncol(l)=rgb(white)
    endif
    for i=0 to nv(k)-1
      if nv(k)=5 then
        f=f5(i,m)
      else
        f=f6(i,m)
      endif
      z1=(nticos(2,f)+zloc)/nticos(3,f)
      xarr(j)=nticos(0,f)*viewplane/z1+xloc
      yarr(j)=nticos(1,f)*viewplane/z1+yloc
      inc j,1
    next i
  next l
  ' Draw the polygon
  polygon nd(),xarr(),yarr(),rgb(black),ncol()
  page copy 1 to 0
loop
end

' data for location of verticies for ticosahedron of edge length 2
data 0,1,3*phi
data 0,1,-3*phi
data 0,-1,3*phi
data 0,-1,-3*phi
data 1,3*phi,0
data 1,-3*phi,0
data -1,3*phi,0
data -1,-3*phi,0
data 3*phi,0,1
data 3*phi,0,-1
data -3*phi,0,1
data -3*phi,0,-1
data 2,(1+2*phi),phi
data 2,(1+2*phi),-phi
data 2,-(1+2*phi),phi
data 2,-(1+2*phi),-phi
data -2,(1+2*phi),phi
data -2,(1+2*phi),-phi
data -2,-(1+2*phi),phi
data -2,-(1+2*phi),-phi
data (1+2*phi),phi,2
data (1+2*phi),phi,-2
data (1+2*phi),-phi,2
data (1+2*phi),-phi,-2
data -(1+2*phi),phi,2
data -(1+2*phi),phi,-2
data -(1+2*phi),-phi,2
data -(1+2*phi),-phi,-2
data phi,2,(1+2*phi)
data phi,2,-(1+2*phi)
data phi,-2,(1+2*phi)
data phi,-2,-(1+2*phi)
data -phi,2,(1+2*phi)
data -phi,2,-(1+2*phi)
data -phi,-2,(1+2*phi)
data -phi,-2,-(1+2*phi)
data 1,(2+phi),2*phi
data 1,(2+phi),-2*phi
data 1,-(2+phi),2*phi
data 1,-(2+phi),-2*phi
data -1,(2+phi),2*phi
data -1,(2+phi),-2*phi
data -1,-(2+phi),2*phi
data -1,-(2+phi),-2*phi
data (2+phi),2*phi,1
data (2+phi),2*phi,-1
data (2+phi),-2*phi,1
data (2+phi),-2*phi,-1
data -(2+phi),2*phi,1
data -(2+phi),2*phi,-1
data -(2+phi),-2*phi,1
data -(2+phi),-2*phi,-1
data 2*phi,1,(2+phi)
data 2*phi,1,-(2+phi)
data 2*phi,-1,(2+phi)
data 2*phi,-1,-(2+phi)
data -2*phi,1,(2+phi)
data -2*phi,1,-(2+phi)
data -2*phi,-1,(2+phi)
data -2*phi,-1,-(2+phi)
' 12 faces with 5 sides
data 0,28,36,40,32
data 1,29,37,41,33
data 2,30,38,42,34
data 3,31,39,43,35
data 4,12,44,45,13
data 5,14,46,47,15
data 6,16,48,49,17
data 7,18,50,51,19
data 8,20,52,54,22
data 9,21,53,55,23
data 10,24,56,58,26
data 11,27,59,57,25
' 20 faces with 6 sides
data 0,2,34,58,56,32
data 0,2,30,54,52,28
data 1,3,31,55,53,29
data 1,3,35,59,57,33
data 4,6,17,41,37,13
data 4,6,16,40,36,12
data 5,7,19,43,39,15
data 5,7,18,42,38,14
data 8,9,23,47,46,22
data 8,9,21,45,44,20
data 10,11,27,51,50,26
data 10,11,25,49,48,24
data 12,44,20,52,28,36
data 13,45,21,53,29,37
data 14,46,22,54,30,38
data 15,47,23,55,31,39
data 16,48,24,56,32,40
data 17,49,25,57,33,41
data 18,50,26,58,34,42
data 19,51,27,59,35,43

